--*******************************************--
--*			inputs lib v0.1 by Daaa			*--
--*				   03/27/07 				*--
--*											*--
--*	If you use this, please mention my name *--
--*	somewhere in your credits.				*--
--*											*--
--*******************************************--

--I use Daaa at the end to make sure nobody wants to have a var with the same name
inputNamesDaaa={"cross", "square", "circle", "triangle", "l", "r", "start", "select", "up", "down", "left", "right"}
inputStatesDaaa={}

inputWatcherDaaa={}
for key, value in pairs(inputNamesDaaa) do
	inputWatcherDaaa[value]={}
	inputWatcherDaaa[value]["timer"]=Timer.new(0)
	inputWatcherDaaa[value]["timer"]:reset()
	inputWatcherDaaa[value]["firstPress"]=false
	inputWatcherDaaa[value]["isPressed"]=false
	inputWatcherDaaa[value]["repeatTimer"]=Timer.new(0)
	inputWatcherDaaa[value]["repeatTimer"]:reset()
	inputWatcherDaaa[value]["justReleased"]=false
end
--special case for the analog stick, we just want to know if it's touched
inputWatcherDaaa["analog"]=false

inputNamesDaaa=nil

INPUT={}

--default values
inputAnalogSensibility=50
inputLongPressTime=350
inputRepeatInterval=100

function INPUT.setAnalogSensibility(val)
	val=val or 50
	inputAnalogSensibility=val
	return inputAnalogSensibility
end

function INPUT.setLongPressTime(val)
	val=val or 350
	inputLongPressTime=val
	return inputLongPressTime
end

function INPUT.setRepeatInterval(val)
	val=val or 100
	inputRepeatInterval=val
	return inputRepeatInterval
end

function INPUT.getAnalogSensibility()
	return inputAnalogSensibility
end

function INPUT.getLongPressTime()
	return inputLongPressTime
end

function INPUT.getRepeatInterval()
	return inputRepeatInterval
end

--internal
function getInputStates(pad)
	pad=pad or Controls.read()
	
	inputStatesDaaa["cross"]=pad:cross()
	inputStatesDaaa["square"]=pad:square()
	inputStatesDaaa["circle"]=pad:circle()
	inputStatesDaaa["triangle"]=pad:triangle()
	inputStatesDaaa["l"]=pad:l()
	inputStatesDaaa["r"]=pad:r()
	inputStatesDaaa["start"]=pad:start()
	inputStatesDaaa["select"]=pad:select()
	inputStatesDaaa["up"]=pad:up()
	inputStatesDaaa["down"]=pad:down()
	inputStatesDaaa["left"]=pad:left()
	inputStatesDaaa["right"]=pad:right()
	return inputStatesDaaa
end

function INPUT.update(pad)
	pad=pad or Controls.read()
	
	for key, value in pairs(getInputStates(pad)) do
		if value then
			time=inputWatcherDaaa[key]["timer"]:time()
			if time==0 then --if he just pressed the key
				inputWatcherDaaa[key]["timer"]:start()
				inputWatcherDaaa[key]["firstPress"]=true
			else --it is pressed since some time
				inputWatcherDaaa[key]["firstPress"]=false
			end
			inputWatcherDaaa[key]["isPressed"]=true
		else --doesn't push cross so stop it in the case he released it	
			inputWatcherDaaa[key]["timer"]:reset()
			inputWatcherDaaa[key]["firstPress"]=false
			if inputWatcherDaaa[key]["isPressed"]==true then
				inputWatcherDaaa[key]["justReleased"]=true
			else
				inputWatcherDaaa[key]["justReleased"]=false
			end
			inputWatcherDaaa[key]["isPressed"]=false
			inputWatcherDaaa[key]["repeatTimer"]:reset()
		end
	end
	
	
	if 	pad:analogY()>inputAnalogSensibility or pad:analogY()<-inputAnalogSensibility
		or pad:analogX()>inputAnalogSensibility or pad:analogX()<-inputAnalogSensibility then
		inputWatcherDaaa["analog"]=true
	else
		inputWatcherDaaa["analog"]=false
	end
	
end

function INPUT.firstPress(inp)
	if inputWatcherDaaa[inp]["firstPress"] then
		inputWatcherDaaa[inp]["firstPress"]=false
		return true
	end
	return false
end

function INPUT.longPress(inp)
	if inputLongPressTime<=inputWatcherDaaa[inp]["timer"]:time() then
		return true
	end
	return false
end

function INPUT.pressedDuring(inp, time)
	if time<=inputWatcherDaaa[inp]["timer"]:time() then
		return true
	end
	return false
end

function INPUT.isPressed(inp)
	return inputWatcherDaaa[inp]["isPressed"]
end

function INPUT.isRepeating(inp)
	--starts the timer if not already
	if inputWatcherDaaa[inp]["repeatTimer"]:start()>=inputRepeatInterval then
		inputWatcherDaaa[inp]["repeatTimer"]:reset()
		inputWatcherDaaa[inp]["repeatTimer"]:start()
		return true
	end
	return false
end

function INPUT.isRepeatingAfterLongPress(inp)
	if INPUT.longPress(inp) then
		--starts the timer if not already
		if inputWatcherDaaa[inp]["repeatTimer"]:start()>=inputRepeatInterval then
			inputWatcherDaaa[inp]["repeatTimer"]:reset()
			inputWatcherDaaa[inp]["repeatTimer"]:start()
			return true
		end
	end
	return false
end

function INPUT.justReleased(inp)
	return inputWatcherDaaa[inp]["justReleased"]
end

function INPUT.analogIsTouched()
	return inputWatcherDaaa["analog"]
end



--should be used only for debugging purposes
function INPUT.timePressed(inp)
	return inputWatcherDaaa[inp]["timer"]:time()
end









